﻿Procedure ImageToColor(image, newcolor)
  Protected w, h, x, y, v, gray
  w = ImageWidth(image)
  h = ImageHeight(image)
  StartDrawing(ImageOutput(image))
  For x = 0 To w - 1
    For y = 0 To h - 1
      gray = Point(x, y)
      Plot(x, y, newcolor)
    Next
  Next
  StopDrawing()
EndProcedure

Procedure draw_box_lined_flat(parent_canvas, value.f, units_text$="n/a",fntcol = 0, iconimg = -1, bgcol = 0,barcol = 0, min.f = 0, max.f = 100, decimals = 0, segments = 25)
  If StartVectorDrawing(CanvasVectorOutput(parent_canvas))
    AddPathBox(0, 0, GadgetWidth(parent_canvas), GadgetWidth(parent_canvas))
    VectorSourceColor(RGBA(255,255,255,255))   
    FillPath()   
    
    If iconimg = - 1
      MovePathCursor(GadgetHeight(parent_canvas)/8, GadgetHeight(parent_canvas) /2 - GadgetHeight(parent_canvas) /4)
    Else
      MovePathCursor(GadgetHeight(parent_canvas)/7, GadgetHeight(parent_canvas) /2 - GadgetHeight(parent_canvas) /4)
      ImageToColor(iconimg, fntcol)
      DrawVectorImage(ImageID(iconimg), 255, GadgetHeight(parent_canvas)/2.1, GadgetHeight(parent_canvas)/2.1)
    EndIf

    If value < min Or value > max
      VectorFont(FontID(0), GadgetHeight(parent_canvas)/1.8)
      VectorSourceColor(RGBA(255,0,0,255))
      text$ = "Out of range!"
      MovePathCursor(GadgetWidth(parent_canvas)/2,(GadgetHeight(parent_canvas)/2) - (VectorTextHeight(text$)/2));
      DrawVectorText(text$)
    Else
      
      AddPathBox(GadgetWidth(parent_canvas)/80,GadgetHeight(parent_canvas)/12,  GadgetWidth(parent_canvas) - (GadgetWidth(parent_canvas)/40), (GadgetHeight(parent_canvas) - GadgetHeight(parent_canvas)/6 ))
      StrokePath(1)
      
      If fntcol = 0
        VectorSourceColor(RGBA(0,0,0,255))
      Else
        VectorSourceColor(fntcol)
      EndIf
      
      VectorFont(FontID(0), GadgetHeight(parent_canvas)/1.8)
      text$ = StrF(value,decimals)
      MovePathCursor(GadgetWidth(parent_canvas)/3.8 - VectorTextWidth(text$),(GadgetHeight(parent_canvas)/2) - (VectorTextHeight(text$)/2));
      DrawVectorText(text$)
      
      VectorFont(FontID(0), GadgetHeight(parent_canvas)/3)
      MovePathCursor(GadgetWidth(parent_canvas)/3.7,(GadgetHeight(parent_canvas)/2) - (VectorTextHeight(units_text$)/4));
      DrawVectorText(units_text$)
      
      If barcol = 0
        barcol = RGBA(0, 0, 0, 255)
      EndIf 
      
      Color32.q = barcol
      Color32 = Color32 & $FFFFFFFF 
      
      If Alpha(Color32) > 210
        VectorSourceColor(RGBA(Red(Color32), Green(Color32), Blue(Color32),  Alpha(Color32) - 200))
      EndIf

      graph_width.f =  (2 *GadgetWidth(parent_canvas)/3) - GadgetWidth(parent_canvas)/40
      segment_width = (graph_width/segments)
      beginx = GadgetWidth(parent_canvas)/3 + GadgetWidth(parent_canvas)/40

      For i = 0 To segments - 1
        MovePathCursor(beginx + (segment_width * i), GadgetHeight(parent_canvas)/4)
        AddPathLine(beginx + (segment_width * i) , 3 *(GadgetHeight(parent_canvas)/4) ) 
        StrokePath(GadgetWidth(parent_canvas)/80, #PB_Path_RoundEnd);
      Next
      
      range = Abs(max - min)
      position.f = value/range + Abs(min)/range
      
      VectorSourceColor(barcol)
      
      For i = 0 To (segments - 1)*position
        MovePathCursor(beginx + (segment_width * i), GadgetHeight(parent_canvas)/4)
        AddPathLine(beginx + (segment_width * i) , 3 *(GadgetHeight(parent_canvas)/4) ) 
        StrokePath(GadgetWidth(parent_canvas)/80, #PB_Path_RoundEnd);
      Next 
      
    EndIf
    StopVectorDrawing()
  EndIf
EndProcedure

UsePNGImageDecoder()

If OpenWindow(0, 0, 0, 320, 200, "Flat Bargraph Horizontal", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_SizeGadget)
  AddWindowTimer(0, 123, 500)
  LoadFont(0, "Verdana", 20,  #PB_Font_HighQuality); | #PB_Font_Bold
  LoadImage(0, #PB_Compiler_FilePath  + "/icons/weather.png")
  LoadImage(1, #PB_Compiler_FilePath  + "/icons/humidity.png")
  CanvasGadget(10, 0, 0,WindowWidth(0), WindowHeight(0)/5)
  CanvasGadget(11, 0, WindowHeight(0)/5, WindowWidth(0), WindowHeight(0)/5)
  CanvasGadget(12, 0, 2 * WindowHeight(0)/5, WindowWidth(0), WindowHeight(0)/5)
  CanvasGadget(13, 0, 3 * WindowHeight(0)/5, WindowWidth(0), WindowHeight(0)/5)
  CanvasGadget(14, 0, 4 * WindowHeight(0)/5, WindowWidth(0), WindowHeight(0)/5)
  Repeat
    
    If Event = #PB_Event_Timer And EventTimer() = 123
      draw_box_lined_flat(10,Random(100,0))
      draw_box_lined_flat(11,(Random(700,0)-200)/10,"°C",RGBA(3,37,126,255),0,0,RGBA(3,37,126,255),-20,50)
      draw_box_lined_flat(12,Random(100,0),"%",RGBA(0,95,97,255),1,0,RGBA(0,95,97,255),0,100,0)
      draw_box_lined_flat(13,Random(100,0),"%",RGBA(21,71,52,255),1,0,RGBA(21,71,52,255),0,100,0)
      draw_box_lined_flat(14,Random(100,0),"%",RGBA(30,30,30,255),1,0,RGBA(255,140,0,255),0,100,0)
      
    EndIf
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf
; IDE Options = PureBasic 5.71 LTS (Windows - x64)
; CursorPosition = 93
; FirstLine = 77
; Folding = -
; EnableXP